﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
Sub Class_Globals
	Private pnlDP As Panel
	Private Cmodule As Object

	Dim Tag As String

	Dim Number As String

	Private cnv As Canvas
	
	Dim Width As Long
	Dim Height As Long
	
	Private Max_Digits As Int
	
	Private BackGroundColor As Long
	Private OnColor As Long
	Private OffColor As Long
	
	Private Digits(10) As String
	Digits(0)="1110111"
	Digits(1)="0010010"
	Digits(2)="1011101"
	Digits(3)="1011011"
	Digits(4)="0111010"
	Digits(5)="1101011"
	Digits(6)="1101111"
	Digits(7)="1010010"
	Digits(8)="1111111"
	Digits(9)="1111011"
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(module As Object, X_Dimension As Long, Y_Dimension As Long, MaxDigits As Int, _
				ColorBackGround As Long, ColorIsOn As Long, ColorIsOff As Long)
	
	pnlDP.Initialize("pnl")
	pnlDP.Width = X_Dimension
	pnlDP.Height = Y_Dimension	
	'Set Attributes
	Width = X_Dimension
	Height = Y_Dimension
	Max_Digits = MaxDigits
	BackGroundColor = ColorBackGround
	OnColor = ColorIsOn
	OffColor = ColorIsOff
	Number = CreateAllDigits("")
	Cmodule = module
	
	pnlDP.Color = ColorBackGround
	cnv.Initialize(pnlDP)
End Sub

Public Sub DrawPanel
	Dim ii As Int
	
	Dim rct As Rect
	rct.Initialize(0,0, Width, Height)
	cnv.DrawRect(rct, BackGroundColor, True,1)
	
	If Number = "" Then
		ToastMessageShow("Please set the number to display.", True)
		Number = CreateAllDigits("")
	End If
	
	For ii = 0 To Number.Length - 1
		Dim sDigit As String = Number.SubString2(ii,ii+1)
		If "0123456789".IndexOf(sDigit) = -1 Then
			ToastMessageShow("You have set a non numeric character to display.", True)
			Number = CreateAllDigits("")
			Exit
		End If
	Next
	
	Number = CreateAllDigits(Number)
	
	For ii = 1 To Number.Length
		DrawDigit(ii)
	Next
End Sub

Private Sub DrawDigit(iU As Int)
	Dim sDigit As String = Number.SubString2(iU-1, iU)
	Dim iDigit As Int = sDigit
	
	Dim sPattern As String = Digits(iDigit)
	
	Dim xDim As Long = (Width-((Max_Digits+1)*10)) / Max_Digits
	Dim YDim As Long = Height
	
	Dim ii As Int
	Dim DrawColor As Long
	
	Dim Y1 As Long = xDim * 0.15
	Dim Y2 As Long = YDim * 0.15
	Dim Y As Long = Max(Y1,Y2)

	If Y/xDim >0.25 Or Y/YDim > 0.25 Then
		Y = Min(Y1,Y2)
	End If
	
	Dim X As Long = xDim - Y - 4
	Dim X2 As Long = (YDim - 16 - Y - 4 - 4)/2
	
	
	
	For ii = 1 To 7
		Dim sLightOn As String = sPattern.SubString2(ii-1, ii)
		If sLightOn = "1" Then DrawColor = OnColor Else DrawColor = OffColor
		
		Dim pth As Path
		Select ii		
			Case 1 'Upper
				pth.Initialize((iU-1) * xDim + iU * 10 + (Y/2) + 2, 8+(Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + (Y/2), 8)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X - (Y/2), 8)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X, 8+(Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X - (Y/2), 8+Y)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + (Y/2), 8+Y)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2, 8+(Y/2))
			Case 2 'Upper Left
				pth.Initialize((iU-1) * xDim + iU * 10 + (Y/2) - 0, 8+ (Y/2) + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0 + (Y/2), 8 + (Y/2) + 2 + (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0 + (Y/2), 8 + (Y/2) + 2 + X2 - 2 * (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0 , 8 + (Y/2) + 2 + X2 - (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 - 0 , 8 + (Y/2) + 2 + X2 - 2 * (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 - 0 , 8 + (Y/2) + 2 + (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0, 8+ (Y/2) + 2)
			Case 3 'Upper Right
				pth.Initialize((iU-1) * xDim + iU * 10 + (Y/2) - 2 + X + 6, 8+ (Y/2) + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + (Y/2) + X + 6, 8 + (Y/2) + 2 + (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + (Y/2) + X + 6, 8 + (Y/2) + 2 + X2 - 2 * (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + X + 6, 8 + (Y/2) + 2 + X2 - (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 - 2 + X + 6, 8 + (Y/2) + 2 + X2 - 2 * (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 - 2 + X + 6, 8 + (Y/2) + 2 + (Y/2))
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + X + 6, 8+ (Y/2) + 2)
			Case 4 'Center
				pth.Initialize((iU-1) * xDim + iU * 10 + (Y/2) + 2, 8+(Y/2) + X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + (Y/2), 8 + X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X - (Y/2), 8 + X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X, 8+(Y/2)+ X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X - (Y/2), 8+Y+ X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + (Y/2), 8+Y+ X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2, 8+(Y/2)+ X2)
			Case 5 'Lower Left
				pth.Initialize((iU-1) * xDim + iU * 10 + (Y/2) - 0, 8+ (Y/2) + 2 + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0 + (Y/2), 8 + (Y/2) + 2 + (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0 + (Y/2), 8 + (Y/2) + 2 + X2 - 2 * (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0 , 8 + (Y/2) + 2 + X2 - (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 - 0 , 8 + (Y/2) + 2 + X2 - 2 * (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 - 0 , 8 + (Y/2) + 2 + (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 0, 8+ (Y/2) + 2 + X2 + 2)
			Case 6 'Lower Right
				pth.Initialize((iU-1) * xDim + iU * 10 + (Y/2) - 2 + X + 6, 8+ (Y/2) + 2 + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + (Y/2) + X + 6, 8 + (Y/2) + 2 + (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + (Y/2) + X + 6, 8 + (Y/2) + 2 + X2 - 2 * (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + X + 6, 8 + (Y/2) + 2 + X2 - (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 - 2 + X + 6, 8 + (Y/2) + 2 + X2 - 2 * (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 - 2 + X + 6, 8 + (Y/2) + 2 + (Y/2) + X2 + 2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) - 2 + X + 6, 8+ (Y/2) + 2 + X2 + 2)
			Case 7 'Lower
				pth.Initialize((iU-1) * xDim + iU * 10 + (Y/2) + 2, 8+(Y/2) + 2 + 2*X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + (Y/2), 8 + 2 + 2*X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X - (Y/2), 8 + 2 + 2*X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X, 8+(Y/2)+ 2 + 2*X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + X - (Y/2), 8+Y+ 2 + 2*X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2 + (Y/2), 8+Y+ 2 + 2*X2)
				pth.LineTo((iU-1) * xDim + iU * 10 + (Y/2) + 2, 8+(Y/2)+ 2 + 2*X2)
		End Select
		
		cnv.Drawpath(pth, DrawColor, True, 1)
	Next
	
End Sub

Private Sub CreateAllDigits(Num As String) As String
	Dim NumAll As StringBuilder
	NumAll.Initialize
	Dim ii As Int
	For ii = 1 To Max_Digits
		NumAll.Append("0")
	Next
	NumAll.Append(Num)
	Return NumAll.ToString.SubString(NumAll.ToString.Length - Max_Digits)
End Sub

Public Sub GetPanel As Panel
	DrawPanel
	Return pnlDP
End Sub

Public Sub pnl_Click
	If SubExists(Cmodule,"pnlClick") Then
		CallSubDelayed2(Cmodule, "pnlClick", Me)
	End If
End Sub


